"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = convexpress;

require("babel-polyfill");

var _express = require("express");

var _swaggerizeUi = require("swaggerize-ui");

var _swaggerizeUi2 = _interopRequireDefault(_swaggerizeUi);

var _convert = require("./convert");

var convert = _interopRequireWildcard(_convert);

var _parseBody = require("./parse-body");

var _parseBody2 = _interopRequireDefault(_parseBody);

var _validateMiddleware = require("./validate-middleware");

var validate = _interopRequireWildcard(_validateMiddleware);

var _wrap = require("./wrap");

var wrap = _interopRequireWildcard(_wrap);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function convexpress(options) {
    var router = (0, _express.Router)().use((0, _parseBody2.default)());
    router.swagger = {
        swagger: "2.0",
        host: options.host,
        basePath: options.basePath || "/",
        info: options.info,
        consumes: ["application/json"],
        produces: ["application/json"],
        paths: {}
    };
    router.convroute = function (route) {
        // Attach route to router
        var middleware = [validate.middleware(route.parameters)].concat(_toConsumableArray(route.middleware || []));
        router[route.method](route.path, middleware.map(wrap.middleware), wrap.handler(route.handler));
        // Update the swagger document
        var swaggerPath = convert.path(route.path);
        router.swagger.paths[swaggerPath] = _extends({}, router.swagger.paths[swaggerPath], _defineProperty({}, route.method, {
            description: route.description,
            tags: route.tags || [],
            parameters: convert.parameters(route.parameters),
            responses: _extends({}, route.responses, validate.responses)
        }));
        // Allow method chaining
        return router;
    };
    router.serveSwagger = function () {
        router.get("/swagger.json", function (req, res) {
            return res.status(200).send(router.swagger);
        });
        router.use("/swagger", (0, _swaggerizeUi2.default)({ docs: "/swagger.json" }));
        return router;
    };
    return router;
}