"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.handler = handler;
exports.middleware = middleware;

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

/*
*   We use two different but very similar functions because express does a bit
*   of magic with function arities (fn.length). For instance, if a middleware
*   function has length 4, then it is assumed to be an error-handling
*   middleware[1] and is therefore treated differently. As far as I (pscanf)
*   know, the error-handling middleware should be the only case in which
*   function arity is taken into account by express. However, to play it safe,
*   we use a function with length 2 for the handler, and a function with length
*   3 for the middleware.
*
*   [1]: http://expressjs.com/en/guide/error-handling.html
*/

function handler(fn) {
    var _this = this;

    return function () {
        var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(req, res) {
            return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            _context.prev = 0;
                            _context.next = 3;
                            return fn(req, res);

                        case 3:
                            _context.next = 9;
                            break;

                        case 5:
                            _context.prev = 5;
                            _context.t0 = _context["catch"](0);

                            res.status(500).send({
                                message: "Internal server error"
                            });
                            req.log && req.log.error(_context.t0, "Uncaught exception");

                        case 9:
                        case "end":
                            return _context.stop();
                    }
                }
            }, _callee, _this, [[0, 5]]);
        }));

        return function (_x, _x2) {
            return ref.apply(this, arguments);
        };
    }();
}

function middleware(fn) {
    var _this2 = this;

    return function () {
        var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(req, res, next) {
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            _context2.prev = 0;
                            _context2.next = 3;
                            return fn(req, res, next);

                        case 3:
                            _context2.next = 9;
                            break;

                        case 5:
                            _context2.prev = 5;
                            _context2.t0 = _context2["catch"](0);

                            res.status(500).send({
                                message: "Internal server error"
                            });
                            req.log && req.log.error(_context2.t0, "Uncaught exception");

                        case 9:
                        case "end":
                            return _context2.stop();
                    }
                }
            }, _callee2, _this2, [[0, 5]]);
        }));

        return function (_x3, _x4, _x5) {
            return ref.apply(this, arguments);
        };
    }();
}